
package send_money_livre;

import org.chocosolver.solver.constraints.Propagator;
import org.chocosolver.solver.exception.ContradictionException;
import org.chocosolver.solver.variables.IntVar;
import org.chocosolver.util.ESat;


class Mon_Propagateur extends Propagator<IntVar>{
      int nb_appel_au_propagateur;
    
    public Mon_Propagateur(IntVar[] vars){
        super(vars);
        nb_appel_au_propagateur=0;
    }
    
    
    @Override
    public void propagate(int evtmask) throws ContradictionException {
        nb_appel_au_propagateur++;
        for (IntVar var : vars){
            if (var.getDomainSize()==0){
                fails();
            }
            if (var.getDomainSize()==1){
                for (IntVar var2 : vars){
                    if (!var2.equals(var)){
                       var2.removeValue(var.getValue(), var2);
                    }
                }
            }          
        }
    }

   @Override
    public ESat isEntailed() {
    
        for (IntVar var : vars)  // pour x, y et z
        {
            if (var.getDomainSize()==0){
                 return ESat.FALSE;
            }
            if (var.getDomainSize()>1){
               return ESat.UNDEFINED;
            }
        }
        return ESat.TRUE;
    }  
}
