
package send_money_livre;

import org.chocosolver.solver.constraints.Propagator;
import org.chocosolver.solver.exception.ContradictionException;
import org.chocosolver.solver.variables.IntVar;
import org.chocosolver.util.ESat;


class Mon_Propagateur_Somme extends Propagator<IntVar>{
    
    int nb_appel_propagateur_somme;
     
    public Mon_Propagateur_Somme(IntVar[] vars){
      super(vars);
      nb_appel_propagateur_somme=0;
    }

    @Override
    public void propagate(int evtmask) throws ContradictionException {
        nb_appel_propagateur_somme++;
        int[][] matrice_somme= new int[3][5]; 
        matrice_somme[0][0]=-1;	matrice_somme[0][1]=0;	matrice_somme[0][2]=1;
	matrice_somme[0][3]=2;		matrice_somme[0][4]=3;	matrice_somme[1][0]=-1;
	matrice_somme[1][1]=4;		matrice_somme[1][2]=5;	matrice_somme[1][3]=6;
	matrice_somme[1][4]=1;		matrice_somme[2][0]=4;	matrice_somme[2][1]=5;
	matrice_somme[2][2]=2;		matrice_somme[2][3]=1;	matrice_somme[2][4]=7;


        for (int i=1; i<5; i++){
            int n1=matrice_somme[0][i]; 
            int n2=matrice_somme[1][i];
            int n3=matrice_somme[2][i];

            int s1=vars[n1].getLB()+ vars[n2].getLB();
            int s2=vars[n1].getUB()+ vars[n2].getUB();

            if ((s1>vars[n3].getUB()+10 && s1>=10)|| (s1>vars[n3].getUB() && s2<10)){
                fails();
            }
            // UB
            if ((s2+1<vars[n3].getLB()&& s2<10)||(s2+1<vars[n3].getLB()+10&& s1>10)){
                 fails();
            }
        }

        int nb_singleton=0;
        for (IntVar var : vars)  // pour x, y et z
        {
            if (var.getDomainSize()==1){
                nb_singleton++;
            }
            if (var.getDomainSize()==0){
                fails();
           }
        }

        if (nb_singleton==vars.length){
            int[] coeffs = new int[8]; 
            coeffs[0] = 1000;
            coeffs[1] = 91;
            coeffs[2] = -90;
            coeffs[3] = 1;
            coeffs[4] = -9000;
            coeffs[5] = -900;
            coeffs[6] = 10;
            coeffs[7] = -1;

            int somme = 0;
            for (int i=0; i<vars.length; i++){
              somme=somme+coeffs[i]*vars[i].getValue();
            }

            if (somme!=0){
             fails();
            }
         }
    }


    @Override
    public ESat isEntailed() {
        for (IntVar var : vars){
            if (var.getDomainSize()>1){
                return ESat.UNDEFINED;
            }
            if (var.getDomainSize()==0){
                return ESat.FALSE;
            }
        }
        return ESat.UNDEFINED;
    }
}




