package send_money_livre;

import org.chocosolver.solver.Model;
import org.chocosolver.solver.Solution;
import org.chocosolver.solver.Solver;
import org.chocosolver.solver.constraints.Constraint;
import org.chocosolver.solver.search.strategy.Search;
import org.chocosolver.solver.search.strategy.strategy.IntStrategy;
import org.chocosolver.solver.variables.IntVar;

public class Send_Money_Livre {

    public static void main(String[] args) {
        
        // Etape 1. Declaration du modÃ¨le
        Model mon_modele = new Model("Send More Money");
        
        // Etape 2. DÃ©finition des variables et de leurs domains respectifs.
        IntVar[] vars = new IntVar[8];
        vars[0] = mon_modele.intVar("S", 1, 9);
        vars[1] = mon_modele.intVar("E", 0, 9);
        vars[2] = mon_modele.intVar("N", 0, 9);
        vars[3] = mon_modele.intVar("D", 0, 9);
        vars[4] = mon_modele.intVar("M", 1, 9);
        vars[5] = mon_modele.intVar("0", 0, 9);
        vars[6] = mon_modele.intVar("R", 0, 9);
        vars[7] = mon_modele.intVar("Y", 0, 9);

        // Etape 3 bis : notre propre propagateur     
        
        // (C1 bis)
        Mon_Propagateur Propage=new Mon_Propagateur(vars); 
        Constraint Une_Contrainte= new Constraint ("Contrainte Different", Propage);
        Une_Contrainte.post();

        // (C2 bis)
        Mon_Propagateur_Somme Propage2=new Mon_Propagateur_Somme(vars); 
        Constraint Une_Contrainte2 = new Constraint("Contrainte Somme", Propage2);
        Une_Contrainte2.post();      

        //Etape 4. RÃ©solution du problÃ¨me
        Solver solv = mon_modele.getSolver();
        Solution solution = mon_modele.getSolver().findSolution();
  
        Mon_selecteur_Card_Max selecteur_1 = new Mon_selecteur_Card_Max(); 
        Mon_Int_Value_Max mon_select_value_1 = new Mon_Int_Value_Max(); 
        IntStrategy s1 = Search.intVarSearch(selecteur_1,mon_select_value_1,vars);
        solv.setSearch(s1);
        
         // Etape 5. Affichage de la solution
        if(solution != null)
        {
          System.out.println(solution.toString());
          System.out.println("nb Appel au propagateur de Tous Differents : "+Propage.nb_appel_au_propagateur);
          System.out.println("nb Appel au propagateur de la somme : "+Propage2.nb_appel_propagateur_somme);
        }
        else
           System.out.println("pas de solution");        
    } // fin main
} // fin class
